/******************************************************************************
*
* project name:    Scorch
* file name:       Gamefunc##.c
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     all specific game functions
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include "main-h.h"

//extern-variables
extern INT_HANDLER save_int_1;
extern INT_HANDLER save_int_5;
extern PLAYERINF player[5];
extern LCD_BUFFER homescreen;
extern GAME game;
extern int earth[240];
extern int curfunc;

void Landscape(unsigned int land_factor) {
	
	unsigned int loop1, high;
	
	/*high = LCD_HEIGHT-random(CALC(60,90));
	highold = high;
	
	for (loop1 = 0; loop1 < CALC(160,240); loop1++) {
		high -= (2 + land_factor - random(5 + 2*land_factor));
		if (high > CALC(100,128) - 8) {
			high = CALC(100,128) - 8 - random(land_factor);
		}
		if (high < CALC(47,52)) {
			high += 4;
		}
		earth[loop1] = high;
		if (high-highold >= 2 + land_factor/2 && loop1 != 0) {
			earth[loop1] -= (1+land_factor/2);
		}
		if (highold - high >= 2 + land_factor/2 && loop1 != 0) {
			earth[loop1 - 1] -= (1+land_factor/2); 
		}
		
		highold = high;
		
		//earth[loop1] = 100;
		
	}*/
	
	//high = LCD_HEIGHT - random(CALC(60,90));
	//high = 60 - random(20);
	high = CALC(65,95) - random(10);
	land_factor *= 2;
	land_factor += 2;
	
	for (loop1 = 0; loop1 < CALC(160,240); loop1++) {
		
		high -= (land_factor/2 - random(land_factor + 1));
		
		if (high > CALC(100,128) - 8) {
			high -= random(land_factor);
		}
		else if (high < CALC(47, 52)) {
			high += random(land_factor);
		}
		earth[loop1] = high;
		
		
	}
	
}

void DrawScreen(void) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 <= CALC(159,239); loop1++) {
		
		FastDrawVLine(DPLANE, loop1, earth[loop1], CALC(99,127), A_NORMAL);
		
	}
	
	for (loop1 = 0; loop1 < game.pl_num; loop1++) {
		if (player[loop1].life == 1) {
			Tankset(loop1);
			Tube(loop1);
		}
	}
	
	Dispinf(game.pl_active);
	
}

void InitRound(void) {
	
	//values and display of the beginning
	game.pl_alive = game.pl_num;
	
	if (game.wind_factor == 0) {
		game.wind = 0;
	}
	else if (game.wind_factor == 1) {
		game.wind = 10 - random(20);
	}
	else if (game.wind_factor == 2) {
		game.wind = 25 - random(50);
	}
	else if (game.wind_factor == 3) {
		game.wind = 50 - random(100);
	}
	//game.wind = 0;
	
	//for each player
	for (game.pl_active = 0; game.pl_active < game.pl_num; game.pl_active++) {
		
		if (player[game.pl_active].type == 2) {
			//beginning-values for the ai
			/*while (player[game.pl_active].hit == game.pl_active) {
				player[game.pl_active].hit = random(game.pl_num);
			}*/
			//chose the angle
			//#if defined(TESTING)
			ChooseEnnemi(game.pl_active, FALSE);
			/*#else
			if (game.wind >= 0) {
				player[game.pl_active].angle = 10 + random(70);
			}
			if (game.wind < 0) {
				player[game.pl_active].angle = 100 + random (70);
			}
			#endif*/
			
			player[game.pl_active].angle_img = player[game.pl_active].angle;
			
		}
		
		player[game.pl_active].bomb[0] = 1;
		player[game.pl_active].health = 10;
		player[game.pl_active].x = 15 + random(CALC(10,15)) + game.pl_active*(LCD_WIDTH / game.pl_num);
		player[game.pl_active].life = 1;
		player[game.pl_active].protect = 0;
		player[game.pl_active].shield = 0;
		
	}
	
}

//void Tankset(PLAYERINF *player) {
void Tankset(unsigned int num) {
	
	#if defined(TESTING)
	int loop1;
	#endif
	
	player[num].y = CALC(17,21);
	
	player[num].y = earth[player[num].x] - 1;
	
	#if defined(TESTING)
	for (loop1 = -3; loop1 <= 3; loop1++) {
		
		if (earth[player[num].x + loop1] < earth[player[num].x]) {
			
			earth[player[num].x + loop1] = earth[player[num].x];
			
		}
		
	}
	
	FastFilledRect_Draw_R(DPLANE, player[num].x - 3, earth[player[num].x] - 1, player[num].x + 3, CALC(17,21));
	Waitkey();
	FastFilledRect_Erase_R(DPLANE, player[num].x - 3, earth[player[num].x] - 1, player[num].x + 3, CALC(17,21));
	//GrayDrawRect(player[num].x - 3, CALC(17,21), player[num].x + 3, earth[player[num].x] - 1, COLOR_DARKGRAY, RECT_FILLED);
	
	Waitkey();
	#endif
	
	MaskTank(num);
	
	DrawTank(num, player[num].protect);
	
}

void DrawTank(unsigned int num, unsigned int mode) {
	
	GraySprite16_OR(player[num].x-11,player[num].y -4,5,player[num].tank,player[num].tank,LPLANE,DPLANE);
	
	if (mode == 0) {
		GrayDrawRect(player[num].x - 1, player[num].y + 1, player[num].x + 1, CALC(99,127), COLOR_DARKGRAY, RECT_FILLED);
		Tube(num);
	}
	else if (mode == PARACHUTE) {
		Sprite8_OR(player[num].x - 3, player[num].y - 8, 4, parachute, DPLANE);
	}
	/*if (player[num].shield > 0 && num != game.pl_active) {
		Clip_circle(player[num].x, player[num].y - 4, 7, COLOR_BLACK, OUTLINED);
		Clip_circle(player[num].x, player[num].y - 4, 8, COLOR_BLACK, OUTLINED);
		//Clip_circle(player[num].x, player[num].y - 4, 13, COLOR_WHITE);
	}*/
	
}

void MaskTank(unsigned int num) {
	
	Sprite16_AND(player[num].x - 6, player[num].y - 4, 5, tank_mask, DPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 4, 5, tank_mask, LPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, DPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, LPLANE);
	
}

void Tube(unsigned int num) {
	
	int tile = (int)(player[num].angle_img/9);
	
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, DPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, LPLANE);
	
	Sprite8_OR(player[num].x - 4, player[num].y - 8, 4, tube[tile], DPLANE);
	Sprite8_OR(player[num].x - 4, player[num].y - 8, 4, tube[tile], LPLANE);
	
	
}

void MainShot(unsigned int num, TARGET *target) {
	
	if (player[num].bomb[0] < LASERLITTLE) {
		ShotEngine(num, target);
	}
	
	/*MoveTo(1, 21);
			
	printf("%d, %d;", target->x, target->y);
	
	Waitkey();
	
	ClrScr();
	DrawScreen();*/
	
	Explosion(target->x, target->y, num);
	
}

void ShotEngine(unsigned int num, TARGET *target) {
	
	COORDINATES scoord;
	float t = 0;
	scoord.x_new = 0, scoord.y_new = 0; 
	
	target->x = 20; target->y = 30;
	
	int x, y, angle;
	int control1 = 0, loop1 = 0;
	
	angle = (player[num].angle * -1) + 90;
	x = player[num].x + 1 + TUBELENGTH * sin_deg(angle);
	y = player[num].y - 5 - TUBELENGTH * cos_deg(angle);
	scoord.x_old = x, scoord.y_old = y;
	scoord.x_eld = x, scoord.y_eld = y;
	scoord.x_ild = x, scoord.y_ild = y;
	
	EXT_CLRPIX(DPLANE, x, y);
	EXT_CLRPIX(LPLANE, x, y);
	
	while(control1 == 0) {
			
			loop1++;
			
			t+=0.06;
			
			if (_keytest(RR_F2)) {
				game.status = FASTQUIT;
				LeadOut();
			}
			
			scoord.x_new = x + player[num].power*POWERFACTOR*t*sin_deg(angle) + game.wind/2*t;
			scoord.y_new = y - (player[num].power*POWERFACTOR*t*cos_deg(angle) - GRAVITATION*t*t);
			while (scoord.x_new > CALC(159,239)) {
				scoord.x_new-=CALC(160,240);
			}
			while (scoord.x_new < 0) {
				scoord.x_new+=CALC(160,240);
			}
			if (scoord.y_new < CALC(17,21)) {
				scoord.y_new = CALC(17,21);
			}
			//else if (scoord.y_new > CALC(99,127)) {
			//	scoord.y_new = CALC(99,127);
			//}
		
		EXT_CLRPIX(DPLANE, scoord.x_old, scoord.y_old);
		EXT_CLRPIX(LPLANE, scoord.x_old, scoord.y_old);
		EXT_CLRPIX(DPLANE, scoord.x_eld, scoord.y_eld);
		EXT_CLRPIX(LPLANE, scoord.x_ild, scoord.y_ild);
		
		//control1 = EXT_GETPIX(DPLANE, scoord.x_new, scoord.y_new);
		
		/*if (EXT_GETPIX(DPLANE, scoord.x_new, scoord.y_new)) {
			
			control1 = TRUE;
			
			target->x = scoord.x_new;
			target->y = scoord.y_new;
			
			MoveTo(1, 21);
			
			printf("%d, %d; %d, %d", scoord.x_new, scoord.y_new, target->x, target->y);
			
			Waitkey();
			
			ClrScr();
			DrawScreen();
			
		}*/
		
		if (scoord.x_old - scoord.x_new > 100) {
			
			control1 = CheckImpact(scoord.x_old, scoord.y_old, CALC(159,239), scoord.y_old + (scoord.y_new - scoord.y_old)/2, target);
			control1 += CheckImpact(0, scoord.y_old + (scoord.y_new - scoord.y_old)/2, scoord.x_new, scoord.y_new, target);
			
		}
		else if (scoord.x_new - scoord.x_old > 100) {
			
			control1 = CheckImpact(scoord.x_old, scoord.y_old, 0, scoord.y_old + (scoord.y_new - scoord.y_old)/2, target);
			control1 += CheckImpact(CALC(159,239), scoord.y_old + (scoord.y_new - scoord.y_old)/2, scoord.x_new, scoord.y_new, target);
			
		}
		else {
	
			control1 = CheckImpact(scoord.x_old, scoord.y_old, scoord.x_new, scoord.y_new, target);
		}
		
		/*if (control1 != 0) {
			
			//control1 = TRUE;
			
			//target->x = scoord.x_new;
			//target->y = scoord.y_new;
			
			MoveTo(1, 21);
			
			printf("%d, %d; %d, %d", scoord.x_new, scoord.y_new, target->x, target->y);
			
			Waitkey();
			
			ClrScr();
			DrawScreen();
			
		}*/
		
		
		/*if (scoord.y_new == CALC(98,126)) {
			control1 = 1;
			target->x = scoord.x_new;
			target->y = scoord.y_new;
		}*/
		
		if (loop1 <= 1 && control1 != 0) {
			/*if (TestCollide8(player[num].x - 4, player[num].y - 8, target->x - 7, target->y, 4,
					tube[(int)(player[num].angle_img/9)], projectile) == TRUE) {
				control1 = 0;
			}*/
			if (PixCollide8(target->x, target->y, player[num].x - 4, player[num].y - 8, 4, 
					tube[(int)(player[num].angle_img/9)]) != 0) {//== TRUE) {
				control1 = 0;
			}
			
		}
		
		
		if (control1 == 0) {
			EXT_SETPIX(LPLANE, scoord.x_new, scoord.y_new);
			EXT_SETPIX(DPLANE, scoord.x_new, scoord.y_new);
		}
		EXT_SETPIX(DPLANE, scoord.x_old, scoord.y_old);
		EXT_SETPIX(LPLANE, scoord.x_eld, scoord.y_eld);
		
		scoord.x_ild = scoord.x_eld, scoord.y_ild = scoord.y_eld;
		scoord.x_eld = scoord.x_old, scoord.y_eld = scoord.y_old;
		scoord.x_old = scoord.x_new, scoord.y_old = scoord.y_new;
		
		Delay(15);
		
	}
	
	
	EXT_CLRPIX(DPLANE, scoord.x_eld, scoord.y_eld);
	EXT_CLRPIX(LPLANE, scoord.x_ild, scoord.y_ild);
	
	
}

int CheckImpact(int xP, int yP, int xQ, int yQ, TARGET *target) {
	
	int x = xP;
	int y = yP;
	int D = 0;
	int HX = xQ - xP;
	int HY = yQ - yP;
	int xInc = 1;
	int yInc = 1;
	int c, M;
	int on = 0;
	
	if(HX < 0) {
		xInc = -1;
		HX = -HX;
	}
	if(HY < 0) {
		yInc = -1;
		HY = -HY;
	}
	
	if(HY <= HX) {
		
		c = 2 * HX; M = 2 * HY;
		while(TRUE) {
			
			on = EXT_GETPIX(DPLANE, x, y);
			if (on != FALSE) {
    			target->x = x;
    			target->y = y;
    			
    			/*MoveTo(1, 21);
			
					printf("%d; %d, %d; %d, %d", on, x, y, target->x, target->y);
			
					Waitkey();
			
					ClrScr();
					DrawScreen();*/
    			
    			return on;
    	}
			if(x == xQ) {
				return on;
			}
			x += xInc;
			D += M;
			if(D > HX) {
				y += yInc;
				D -=c;
			}
		
		}
		
	}
	else {
		
		c = 2 * HY; M = 2 * HX;
		while(TRUE) {
			
			on = EXT_GETPIX(DPLANE, x, y);
			if (on != FALSE) {
    			target->x = x;
    			target->y = y;			
    			
    			/*MoveTo(1, 21);
			
					printf("%d; %d, %d; %d, %d", on, x, y, target->x, target->y);
			
					Waitkey();
			
					ClrScr();
					DrawScreen();*/
    			
    			return on;
    			
    		}
			if(y == yQ) {
				return on;
			}
			y += yInc;
			D += M;
			if(D > HY) {
				x += xInc;
				D -=c;
			}
		
		} 
		
	}

	return on;

}

void Clip_circle(int xc, int yc, int r, int color, unsigned int mode) {
	int x = 0, y = r, d = 2 * (1 - r);
	int x1, y1, x2;
	
	while (y >= 0) {
		x1 = xc - x;
		x2 = xc + x;
		y1 = yc + y;
		x1 = (x1 < 0) ? 0 : x1;
		x1 = (x1 > CALC(159,239)) ? CALC(159,239) : x1;
		x2 = (x2 < 0) ? 0 : x2;
		x2 = (x2 > CALC(159,239)) ? CALC(159,239) : x2;
		if ((x2 < CALC(159,239)) && ((x2 - x1) > 16)) {        
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayHLine(x1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
			y1 = yc -y;
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayHLine(x1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
		} else {
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayLine(x1, y1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
			y1 = yc - y;
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayLine(x1, y1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
		}
		if(d + y > 0) {
			y--;
			d -= (y << 1) - 1;
		}
		if(x > d) {
			x++;
			d += (x << 1) + 1;
		}
	}
}

/*void CirclePixel(int x1, int x2, int y1) {
		
		EXT_SETPIX(DPLANE, x1, y1); 
		EXT_SETPIX(DPLANE, x2, y1); 
		EXT_SETPIX(LPLANE, x1, y1); 
		EXT_SETPIX(LPLANE, x2, y1);
	
}*/


void Napalm(int x, unsigned int napalm_length) {
	
	unsigned int loop1, loop2, y_loop;
	int x_max, x_min, y;
	unsigned int scenario;
	
	x_max = x;
	x_min = x;
	y = earth[x] - 1;
	
	EXT_SETPIX(LPLANE, x, y);
	EXT_SETPIX(DPLANE, x, y);
	
	for (loop1 = 0; loop1 < napalm_length; loop1++) {
		
		scenario = 0;
		
		if (!EXT_GETPIX(DPLANE, x + 1, y)) {
			scenario = 2;
		}
		if (!EXT_GETPIX(DPLANE, x - 1, y)) {
			scenario++;
		}
		else {
			y--;
		}
		
		if (scenario != 0) {
			
			
			if (scenario == 1) {
				x--;
			}
			else if (scenario == 2) {
				x++;
			}
			else if (scenario == 3) {
				if (random(2) == 0) {
					x--;
				}
				else {
					x++;
				}
			}
			
			for (;!EXT_GETPIX(DPLANE, x, y);y++);
			y--;
		
		}
		
		for (loop2 = 0; loop2 < 42; loop2++) {
			
			#if defined(VTI)
			VTIPoking();
			#else
			pokeIO(0x600005, 0b10111);
			#endif
			
			if (_keytest(RR_F2)) {
				game.status = FASTQUIT;
				LeadOut();
			}
			
		}
		
		EXT_SETPIX(LPLANE, x, y);
		EXT_SETPIX(DPLANE, x, y);
		
		if (x > x_max) {
			x_max = x;
		}
		else if (x < x_min) {
			x_min = x;
		}
		
		if (x == 0) {
			break;
		}
		else if (x == CALC(159,239)) {
			break;
		}
		
	}
	
	scenario = (int)(x_max - x_min)/9;
	if (scenario == 0 || (x_max - x_min)%9 > 4) {
		scenario++;
	}
	
	for (loop1 = 0; loop1 < scenario; loop1++) {
		for (y_loop = CALC(17,21); !EXT_GETPIX(DPLANE, x_min + loop1*9 + 4, y_loop); y_loop++);
		y_loop--;
		
		GrayClipSprite8_OR_R(x_min + loop1*9,  y_loop - 11, 12, fire_l, fire_d, LPLANE, DPLANE);
		
	}
	
	Health_control(1, x_min, x_max);
	
	//Waitkey();
	
	for (loop1 = 0; loop1 < 500; loop1++) {
		#if defined(VTI)
		VTIPoking();
		#else
		pokeIO(0x600005, 0b10111);
		#endif
		
		if (_keytest(RR_F2)) {
			game.status = FASTQUIT;
			LeadOut();
		}
		
	}
	
	GrayClearScreen();
	DrawScreen();
	
}

void Laser(unsigned int num) {
	
	int xy_diff[5][4] = {{0,1,0,-1},{-1,1,-1,0},{1,0,-1,0},{0,1,0,-1},{0,-1,0,1}};
	int x1, x2, xlong, y1, y2, ylong, loop1, color, angle;
	unsigned int width, loop2;
	
	width = bomb_skill[player[num].bomb[0] - 1][2];
	angle = (player[num].angle * -1) + 90;
	x1 = player[num].x + 1 + TUBELENGTH*sin_deg(angle);
	y1 = player[num].y - 5 - TUBELENGTH*cos_deg(angle);
	x2 = x1;
	y2 = y1;
	
	
	for (loop1 = 0; loop1 < 4; loop1++) {
		
		x2 = x1 + width*cos_deg(player[num].angle);
		y2 = y1 - width*sin_deg(player[num].angle);
		
		if (x2 < 1) {
			width = ABS((x1 - 1)/cos_deg(player[num].angle));
		}
		else if (x2 > CALC(158, 238)) {
			width = ABS((CALC(158, 238) - x1)/cos_deg(player[num].angle));
		}
		else if (y2 < CALC(17,22)) {
			width = ABS((y1 - CALC(17,22))/sin_deg(player[num].angle));
		}
		else {
			break;
		}
		
	}
	
	xlong = x2 - x1;
	ylong = y2 - y1;
	
	color = COLOR_LIGHTGRAY;
	
	for (loop1 = 0; loop1 < 20; loop1++) {
		
		if (loop1 == 19) {
			color = 0;
		}
		
		GrayFastDrawLine(x1, y1, x2, y2, color);
		GrayFastDrawLine(x1 + xy_diff[player[num].angle/45][0], 
										 y1 + xy_diff[player[num].angle/45][1], 
										 x1 + xy_diff[player[num].angle/45][0] + xlong, 
										 y1 + xy_diff[player[num].angle/45][1] + ylong, color);
		GrayFastDrawLine(x1 + xy_diff[player[num].angle/45][2], 
										 y1 + xy_diff[player[num].angle/45][3], 
										 x1 + xy_diff[player[num].angle/45][2] + xlong, 
										 y1 + xy_diff[player[num].angle/45][3] + ylong, color);
		
		color++;
		
		if (color > 3) {
			color = 1;
		}
		
		for (loop2 = 0; loop2 <= 46; loop2++) {
			#if defined(VTI)
			VTIPoking();
			#else
			pokeIO(0x600005, 0b10111);
			#endif
			
			if (_keytest(RR_F2)) {
				game.status = FASTQUIT;
				LeadOut();
			}
			
		}
		
	}
	
	Earth_control(x1, x2);
	
}


void Explosion(unsigned int x, unsigned int y, unsigned int num) {
	
	unsigned int loop1, loop2, color = 0, width = 0;
	
	if (y > CALC(98,126)) {
		y = CALC(98,126);
	}
	
	if (player[num].bomb[0] == 0 || num == MASSKILL) {
		width = 6 + random(15);
		num = MASSKILL;
	}
	else if (player[num].bomb[0] == BABYMISSILE) {
		width = 1;
	}
	else {
		--player[num].bomb[player[num].bomb[0]];
		width = bomb_skill[player[num].bomb[0] - 1][2];
	}
	
	if (player[num].bomb[0] <= NUKE || num == MASSKILL) {
		
		/*MoveTo(1, 21);
			
		printf("%d, %d;", x, y);
			
		Waitkey();
			
		ClrScr();
		DrawScreen();*/
		
		for (loop1 = 1; loop1 <= width; loop1++) {
			if (loop1 == width) {
				color = 0;
			}
			Clip_circle(x,y,loop1,color,FILLED);
			color++;
			if (color > 3) {
				color = 0;
			}
			for (loop2 = 0; loop2 <= 46; loop2++) {
				#if defined(VTI)
				VTIPoking();
				#else
				pokeIO(0x600005, 0b10111);
				#endif
			}
			
		}
		//Clip_circle(x,y,width,0,FILLED);
		
		if (num != MASSKILL) {
			Health_control(0, 0, 0);
		}
		
		/*MoveTo(1, 21);
			
		printf("%d, %d;", x, y);
			
		Waitkey();
			
		ClrScr();
		DrawScreen();*/
		
		//Earth_control(x,y,width);
		Earth_control(x - width - 1, x + width + 1);
		
		if (num != MASSKILL) {
			Tank_fall();
		}
	
	}
	else if (player[num].bomb[0] <= HOTNAPALM) {
		
		Napalm(x, width);
		
		//Waitkey();
		
	}
	else if (player[num].bomb[0] <= LASERBIG) {
		
		Laser(num);
		
		Health_control(0, 0, 0);
		
		Tank_fall();
		
	}
	
	//GrayFastDrawHLine(0, CALC(159,239), CALC(99,127), COLOR_DARKGRAY);
	
	if (player[num].bomb[player[num].bomb[0]] == 0) {
		player[num].bomb[0] = 1;
	}
	
}

void Earth_control(int x_min, int x_max) {
	
	int control1, control2, x, y, fall;
	
	/*MoveTo(1, 21);
			
	printf("%d, %d;", x_min, x_max);
			
	Waitkey();*/
	
	if (x_min > x_max) {
		x = x_max;
		x_max = x_min;
		x_min = x;
	}
	
	if (x_min < 0) {
		x_min = 0;
	}
	if (x_max > CALC(159, 239)){
		x_max = CALC(159, 239);
	}
	
	
	for (x = x_min; x <= x_max; x++) {
		
		fall = FALSE;
		
		for (y = CALC(99, 127); y > CALC(17, 21); y--) {
			
			control1 = EXT_GETPIX(DPLANE, x, y);
			control2 = EXT_GETPIX(LPLANE, x, y);
			
			/*EXT_XORPIX(DPLANE, x, y);
			Waitkey();
			EXT_XORPIX(DPLANE, x, y);*/
			
			if (control1 == FALSE && fall == FALSE) {
				earth[x] = y + 1;
				fall = TRUE;
			}
			
			if (fall == TRUE && control1 != FALSE && control2 == FALSE) {
				
				earth[x]--;
				EXT_CLRPIX(DPLANE, x, y);
				EXT_SETPIX(DPLANE, x, earth[x]);
				
			}
			
		}
		
		
	}
	
}


void Health_control(unsigned int bomb, int control_x, int control_y) {
	
	int control_value, tank_pixel, loop2;
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < game.pl_num; loop1++) {
		
		if (player[loop1].life != 0) {
			
			control_value = 0;
			
			if (bomb == 0) {
				
				control_x = 0;
				control_y = 0;
				
				tank_pixel = tank_pixel_mass[player[loop1].tanknum - 1];
				
				for (control_y = player[loop1].y; control_y >= player[loop1].y - 4; control_y--) {
					for (control_x = player[loop1].x - 4; control_x <= player[loop1].x +3; control_x++) {
						
						if (EXT_GETPIX(DPLANE,control_x,control_y) != FALSE && EXT_GETPIX(LPLANE,control_x,control_y) != FALSE) {
							control_value++;
						}
						
					}
				}
				control_value = tank_pixel - control_value;
				//player[loop1].health = player[loop1].health - control_value;
				
				
				GraySprite16_OR(player[loop1].x-11,player[loop1].y -4,5,player[loop1].tank,player[loop1].tank,LPLANE,DPLANE);
				Tube(loop1);
			
			}
			
			else if (bomb == 1) {
				
				for (loop2 = player[loop1].x - 4; loop2 <= player[loop1].x + 4; loop2++) {
					
					if (loop2 >= control_x && loop2 <= control_y) {
						control_value++;
					}
					
				}
				
				control_value *= 2;
				//player[loop1].health -= control_value*2;
					
			}
			
			
			CalcHealth(loop1, control_value);
			
		}
		
	}
	
}

void CalcHealth(unsigned int num, int control_value) {
	
	if (player[num].shield > 0) {
		player[num].shield -= control_value;
		if (player[num].shield < 0) {
			player[num].health += player[num].shield;
			player[num].shield = 0;
		}
	}
	else {
		player[num].health -= control_value;
	}
	
	/*if (player[num].health > 10) {
		player[num].health = 10;
	}*/
	if (player[num].health < 0) {
		player[num].health = 0;
	}
	
}

void Tank_fall(void) {
	
	int yf = 0;
	unsigned int loop1;
	int loop2;
	
	for (loop1 = 0; loop1 < game.pl_num; loop1++) {
	
		if (earth[player[loop1].x] - 1 > player[loop1].y && player[loop1].life != 0) {
			
			if (player[loop1].protect == 0) {
				//MaskTank(loop1);
				
				yf = (int)((earth[player[loop1].x] - 1 - player[loop1].y)/2);
				
				player[loop1].health -= yf;
				
			}
				
			MaskTank(loop1);
			
			for (yf = player[loop1].y; yf < earth[player[loop1].x] - 1; yf++) {
				
				player[loop1].y = yf;
				
				if (player[loop1].protect == PARACHUTE) {
					DrawTank(loop1, PARACHUTE);
				}
				else {
					DrawTank(loop1, 1);
				}
				
				for (loop2 = 0; loop2 < 45; loop2++) {
					
					#if defined(VTI)
					VTIPoking();
					#else
					pokeIO(0x600005, 0b10111);
					#endif
					
					if (_keytest(RR_F2)) {
						game.status = FASTQUIT;
						LeadOut();
					}
							
				}
				
				if (player[loop1].protect == 0) {
					yf++;
				}
				
				MaskTank(loop1);
				
			}
			
			player[loop1].y = earth[player[loop1].x] - 1;
			
			#if defined(TESTING)
			for (loop2 = -3; loop2 <= 3; loop2++) {
				
				if (earth[player[loop1].x + loop2] < earth[player[loop1].x]) {
					
					earth[player[loop1].x + loop2] = earth[player[loop1].x];
					
				}
				
			}
			
			FastFilledRect_Draw_R(DPLANE, player[loop1].x - 3, earth[player[loop1].x] - 1, player[loop1].x + 3, CALC(17,21));
			Waitkey();
			FastFilledRect_Erase_R(DPLANE, player[loop1].x - 3, earth[player[loop1].x] - 1, player[loop1].x + 3, CALC(17,21));
			
			Waitkey();
			#endif
			
			DrawTank(loop1, 0);
			
			
		}
		
	}
	
}

void Inventory(unsigned int num) {
	
	char string[24];
	int position;
	unsigned int page = 1;
	
	WeaponList(num, 1, 0);
	
	position = 1;
	
	while (position > 0) {
		
		position = WeaponCursor(position, page);
		
		if (position == -10) {
			position = 1;
			if (page != 1) {
				page--;
				WeaponList(num, page, 0);
			}
		}
		else if (position == -20) {
			position = 1;
			if (page != PAGES) {
				page++;
				WeaponList(num, page, 0);
			}
		}
		
		else if (position > 0 && player[num].bomb[MERCHPOS] > 0) {
			if (MERCHPOS < BATTERY) {
				player[num].bomb[0] = MERCHPOS;
			}
			else if (MERCHPOS == BATTERY && player[num].health < 10) {
				--player[num].bomb[BATTERY];
				++player[num].health;
				
			}
			else if (MERCHPOS == PARACHUTE && player[num].protect != PARACHUTE) {
				--player[num].bomb[PARACHUTE];
				player[num].protect = PARACHUTE;
				
			}
			else if ((MERCHPOS == SHIELDLITTLE || MERCHPOS == SHIELDBIG)
							&& player[num].shield < bomb_skill[MERCHPOS - 1][2]) {	//nothing to improve :(
				--player[num].bomb[MERCHPOS];
				//player[num].protect += SHIELD;
				player[num].shield = bomb_skill[MERCHPOS - 1][2];
			}
			
			sprintf(string,"%d",player[num].bomb[MERCHPOS]);
			GrayDrawStr2B(CALC(80,115),CALC(25,39) + position*6,(char*)"    ",A_SHADED,DPLANE,DPLANE);
			GrayDrawStr2B(CALC(80,115),CALC(25,39) + position*6,string,A_NORMAL,DPLANE,DPLANE);
			#if defined(TI_BIG)
			Dispinf(num);
			#endif
			FontSetSys(F_4x6);
			
		}
		
	}
	
	GrayClearScreen();
	DrawScreen();
	
	Wait();
	
}

void MassKill(void) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < game.pl_num; loop1++) {
		
		if (player[loop1].life > 0) {
			Explosion(player[loop1].x, player[loop1].y - 4, MASSKILL);
			player[loop1].health = 0;
		}
		
	}
	
	game.pl_alive = 0;
	
}

/*void Clouds(void) {
	//@@@@ no ti89 version@@@@
	int loop, clouds = 10 + random(10);
	
	FastDrawGrayLine(0,41,237,41,COLOR_BLACK);
	
	for (loop = 0; loop <= clouds; loop++) {
		
		ClipSprite16_OR_R(loop*(240/clouds)-5+random(10), 22 + random(14), 6, cloud1, LPLANE);
		
	}
	
}*/

//ti89 version: completely done