/******************************************************************************
*
* project name:    Scorch
* file name:       Gui##.c
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     graphical user interface
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include "main-h.h"

//extern-variables
extern INT_HANDLER save_int_1;
extern INT_HANDLER save_int_5;
extern PLAYERINF player[5];
extern LCD_BUFFER homescreen;
extern GAME game;
extern int earth[240];
extern int curfunc;

void P_R_choose(void) {
	
	char pl_numk[5] = "2",roundsk[5] = "1";
	int key = 0;
	
	//game.ai_factor = 0;
	game.land_factor = 0;
	game.wind_factor = 0;
	game.rounds_now = 1;
	game.rounds = 1;
	game.pl_num = 2;
	
	FontSetSys(CALC(F_6x8,F_8x10));
  GrayDrawStr(CALC(20,35), CALC(62,90), (char*)"(1) Player:    (2-5)", A_NORMAL);
  GrayDrawStr(CALC(20,35), CALC(72,100), (char*)"(2) Rounds:    (1-99)", A_NORMAL);
  GrayDrawStr(CALC(88,125), CALC(62,90), pl_numk, A_NORMAL);
  GrayDrawStr(CALC(88,125), CALC(72,100), roundsk, A_NORMAL);
  GrayDrawStr(CALC(23,20), CALC(87,115), (char*)CALC("[ENTER] to start!!!","Press [ENTER] to start!!!"), A_NORMAL);
  
  while (key != K_ENTER) {
  	
  	while (!(key = KeyPressed()) && game.status != GAMELOADED) {
  		pokeIO(0x600005, 0b10111);
  	}
  	
  	if (game.status == GAMELOADED) {
  		return;
  	}
  	else if (key == K_1) {
  		++game.pl_num;
  		if (game.pl_num > 5) {
  			game.pl_num = 2;
  		}
  		GrayDrawStr(CALC(88,125),CALC(62,90),(char*)"  ",A_SHADED);
  		sprintf(pl_numk,"%d",game.pl_num);
  		GrayDrawStr(CALC(88,125),CALC(62,90),pl_numk,A_NORMAL);
  		
  		Wait();
  		
  	}
  	else if (key == K_2 || key == K_2 + K_2ND) {
  		if (key == K_2) {
  			++game.rounds;
  		}
  		else if (key == K_2 + K_2ND) {
  			game.rounds += 10;
  		}
  		if (game.rounds > 99) {
  			game.rounds = 1;
  		}
  		GrayDrawStr(CALC(88,125), CALC(72,100),(char*)"  ",A_SHADED);
  		sprintf(roundsk,"%d",game.rounds);
  		GrayDrawStr(CALC(88,125), CALC(72,100),roundsk,A_NORMAL);
  		
  		Delay(AUTO_REPEAT);
  		
  	}
  	
  }
  
}

void PlayerSettings(void) {
	
	curfunc = PL_SETTINGS;
	
	//background of initialisation
	Init_background();
	
	//initialisize each player
	for (game.pl_active = 0; game.pl_active < game.pl_num; game.pl_active++) {
		Player_init(game.pl_active);
	}
	
	
}

void Player_init(unsigned int num) {
	
	unsigned int loop1;
	int key = 0;
	char string[16];
	
	Rectangle();
  sprintf(string,"PLAYER %d",num+1);
  GrayDrawStrExt(0,CALC(16,30), string, A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
  
  GrayDrawStrExt2B(CALC(20,55),CALC(31,45),(char*)"(1) Human",A_NORMAL,F_6x8,DPLANE,DPLANE);
  GrayDrawStrExt2B(CALC(20,55),CALC(43,57),(char*)"(2) Computer",A_NORMAL,F_6x8,DPLANE,DPLANE);
  while (key != K_1 && key != K_2) {
  	
  	while (!(key = KeyPressed())) {
  		pokeIO(0x600005, 0b10111);
  	}
  	
  }
  
  Rectangle();
  GrayDrawStrExt(0,CALC(16,30), string, A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
  
  if (key == K_1) {
  	//GrayDrawStrExt(CALC(20,55),CALC(40,55),(char*)"          ",A_SHADED,F_6x8);
  	//GrayDrawStrExt(CALC(20,55),CALC(53,67),(char*)"             ",A_SHADED,F_6x8);
  	Wait();
  	
  	Inputstr(player[num].name,8); 
  	
  	player[num].angle = 45;
  	player[num].angle_img = player[num].angle;
  	player[num].power = 1;
  	player[num].type = 1;
  	
  }
  
  else if (key == K_2) {
  	
  	Wait();
  	
  	key = 0;
  	
  	strcpy(player[num].name, compnames[num]);
  	
  	player[num].strength = 0;
  	
  	for (loop1 = 1; loop1 <= AISTRENGTH; loop1++) {
  		
  		sprintf(string, "(%d) %s", loop1, aistrenght[loop1 - 1]);
  		
  		GrayDrawStrExt2B(CALC(20,55),CALC(19, 33) + loop1*12 ,string,A_NORMAL,F_6x8,DPLANE,DPLANE);
			
		}
		
		while (key < K_1 || key > K_3) {
			
			key = KeyPressed();
			
			pokeIO(0x600005, 0b10111);
			
		}
		
		player[num].strength = key;
		
		if (player[num].strength == AISTRENGTH) {
			
			player[num].strength = random(AISTRENGTH);
			
		}
  	
  	
  	player[num].angle = 0;
  	player[num].angle_img = player[num].angle;
  	/*#if defined(TESTING)
  	//player[num].power = 15 + random(50);
  	//player[num].attempts = 0;
  	//player[num].target = 1;
  	//ChooseEnnemi(num);
  	
  	#else
  	player[num].power = 1 + random(99);
  	#endif*/
  	player[num].type = 2;
  	//player[num].hit = 10;
  	//player[num].try = 0;
  	
  }
  
  player[num].victory = 0;
  #if defined(TESTING)
  player[num].credits = 5000;
  #else
  player[num].credits = 0;
  #endif
  
  for (loop1 = 1; loop1 <= MERCH; loop1++) {
		#if defined(TESTING)
		player[num].bomb[loop1] = 50;
		#else
		player[num].bomb[loop1] = 0;
		#endif
		
	}
	player[num].bomb[0]=1;
	player[num].bomb[1]=99;
	
	Tankchose(num);
	
	//Debugging(num);
	
}

void DrawSettings(void) {
	
	Rectangle();
	GrayDrawStrExt(0, CALC(16,30), (char*)"GAMEOPTIONS", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	FontSetSys(F_4x6);
	GrayDrawStr2B(CALC(15,50),CALC(31,45),"(1)  landscape:",A_NORMAL,DPLANE,DPLANE);
	GrayDrawStr2B(CALC(75,110),CALC(31,45),landscape[game.land_factor],A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(15,50),CALC(39,53),"(2)  aistrenght:",A_NORMAL,DPLANE,DPLANE);
	//GrayDrawStr2B(CALC(75,110),CALC(39,53),aistrenght[game.ai_factor],A_NORMAL,DPLANE,DPLANE);
	GrayDrawStr2B(CALC(15,50),CALC(39,53),"(2)  wind:",A_NORMAL,DPLANE,DPLANE);
	GrayDrawStr2B(CALC(75,110),CALC(39,53),wind[game.wind_factor],A_NORMAL,DPLANE,DPLANE);
	
}

void GameSettings(void) {
	
	int key = 0;
	
	curfunc = GA_SETTINGS;
	
	DrawSettings();
	
	Wait();
	
	while (key != K_ENTER) {
		
		while (!(key = KeyPressed())) {
  		pokeIO(0x600005, 0b10111);
  	}
		
		if (key == K_1) {
			Wait();
			++game.land_factor;
			if (game.land_factor > 6) {
				game.land_factor = 0;
			}
			DrawSettings();
		}
		
		/*else if (key == K_2) {
			Wait();
			++game.ai_factor;
			if (game.ai_factor > 2) {
				game.ai_factor = 0;
			}
			DrawSettings();
		}*/
		
		else if (key == K_2) {
			Wait();
			++game.wind_factor;
			if (game.wind_factor > 4) {
				game.wind_factor = 0;
			}
			DrawSettings();
		}
		
	}
	
	Wait();
	
	if (game.land_factor == 6) {
		game.land_factor = random(6);
	}
	/*if (game.ai_factor == 2) {
		game.ai_factor = random(2);
	}*/
	if (game.wind_factor == 4) {
		game.wind_factor = random(4);
	}
	
}

void Statistics(void) {
	
	unsigned int loop1;
	char string[30];
	
	curfunc = STATISTICS;
			
	// find the player who won the round --> credits
	for (game.pl_check = 0; game.pl_check < game.pl_num; game.pl_check++) {
		
		
		if (player[game.pl_check].health > 0) {
			player[game.pl_check].victory ++;
			
			if (player[game.pl_check].credits < 58000) {
				player[game.pl_check].credits += 2000;
			}
			
		}
		
	}
	
	Rectangle();
	GrayDrawStrExt(0, CALC(16,30), (char*)"STATISTICS", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	FontSetSys(F_4x6);
	for (loop1 = 0; loop1 < game.pl_num; loop1++) {
		GrayDrawStr(CALC(15,50),CALC(31,45) + loop1*7, player[loop1].name, A_NORMAL);
		sprintf(string,"%d",player[loop1].victory);
		GrayDrawStr2B(CALC(75,110), CALC(31,45) + loop1*7,string,A_NORMAL, DPLANE,DPLANE);
		sprintf(string,"%u",player[loop1].credits);
		GrayDrawStr2B(CALC(95,130), CALC(31,45) + loop1*7,string,A_NORMAL, DPLANE,DPLANE);
		GrayDrawStr2B(CALC(135,180), CALC(31,45) + loop1*7,(char*)"cr.",A_NORMAL,DPLANE,DPLANE);
		
		sprintf(string, "after %d of %d round(s)", game.rounds_now, game.rounds);
		GrayDrawStrExt(0, CALC(78,92), string, A_NORMAL | A_CENTERED, F_6x8);
		
	}
	
	//Waitkey();
	
}

void WeaponList(unsigned int num, unsigned int page, unsigned int mode) {
	
	int loop1;
	char string[24];
	
	Rectangle();
	
	if (mode == SHOP) {
		sprintf(string,"SHOP Player %d",num+1);
	}
	else {
		sprintf(string,"INVENTORY Player %d",num + 1);
	}
	GrayDrawStrExt(0, CALC(16,30), string, A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	FontSetSys(F_4x6);
	
	for (loop1 = 1; loop1 <= merchpage[page - 1]; loop1++) {
		
		GrayDrawStr2B(CALC(15,50),CALC(25,39) + loop1*6, bombname[loop1 + (page - 1)*MPP],A_NORMAL,DPLANE,DPLANE);
		sprintf(string,"%d",player[num].bomb[loop1 + (page - 1)*MPP]);
		GrayDrawStr2B(CALC(80,115),CALC(25,39) + loop1*6,string,A_NORMAL,DPLANE,DPLANE);
		if (mode == SHOP) {
			GrayDrawStr2B(CALC(100,135),CALC(25,39) + loop1*6,bombcost[loop1 - 1 + (page - 1)*MPP],A_NORMAL,DPLANE,DPLANE);
		}
	}
	
	WeaponStatusLine(num, page);
	
}

void WeaponStatusLine(unsigned int num, unsigned int page) {
	
	char string[16];
	
	FastFilledRect_Draw_R(DPLANE,CALC(6,41),CALC(84,95),CALC(154,199),CALC(90,101));
	
	sprintf(string,"%u cr.",player[num].credits);
	GrayDrawStr2B(CALC(10,45), CALC(85,96),string,A_REVERSE,DPLANE,DPLANE);
	GrayDrawStr2B(CALC(53,96), CALC(85,96),(char*)"[ESC] = GO ON",A_REVERSE,DPLANE,DPLANE);
	sprintf(string,"\x15 page %d / %d \x16", page, PAGES);
	GrayDrawStr2B(CALC(105,150), CALC(85,96), string, A_REVERSE, DPLANE, DPLANE);
	
}

int WeaponCursor(int position, unsigned int page) {
	
	int key = 0;
	
	while (position > 0 && key != K_ENTER) {
		
		GrayDrawStr(CALC(9,44),CALC(25,39) + position * 6,(char*)">",A_NORMAL);
		
		while (!(key = KeyPressed())) {
  		pokeIO(0x600005, 0b10111);
  	}
		
		//if (key == K_ENTER) {
			//return position;
		//}
		if (key == K_ESC) {
			position = -1;
			//return position;
		}
		
		GrayDrawStr(CALC(9,44),CALC(25,39) + position * 6,(char*)"  ",A_SHADED);
		if (key == K_DOWN) {
			position++;
		}
		else if (key == K_UP) {
			position--;
		}
		else if (key == K_LEFT) {
			position = -10;
		}
		else if (key == K_RIGHT) {
			position = -20;
		}
		
		if (position > merchpage[page - 1]) {
			position = 1;
		}
		if (position == 0) {
			position = merchpage[page - 1];
		}
		Wait();
		//Delay(AUTO_REPEAT);
		
	}
	
	if (position > 0) {	
		GrayDrawStr(CALC(9,44),CALC(25,39) + position * 6,(char*)"  ",A_SHADED);
	}
	
	return position;
	
}

void Shop(unsigned int num) {
	
	int position;
	char string[16];
	unsigned int page = 1;
	
	curfunc = SHOP;
	
	WeaponList(num, page, SHOP);
	
	position = 1;
	
	while (position > 0) {
		
		position = WeaponCursor(position, page);
		
		if (position == -10) {
			position = 1;
			if (page != 1) {
				page--;
				WeaponList(num, page, SHOP);
			}
		}
		else if (position == -20) {
			position = 1;
			if (page != PAGES) {
				page++;
				WeaponList(num, page, SHOP);
			}
		}
		
		else if (position > 0 && player[num].bomb[MERCHPOS] < 90) {
			
			if (player[num].credits >= bomb_skill[MERCHPOS - 1][1]) {
				player[num].bomb[MERCHPOS] += bomb_skill[MERCHPOS - 1][0];
				player[num].credits -= bomb_skill[MERCHPOS - 1][1];
			}
			FontSetSys(F_4x6);
			GrayDrawStr2B(CALC(80,115), CALC(25,39) + position*6,"    ",A_SHADED,DPLANE,DPLANE);
			sprintf(string,"%d",player[num].bomb[MERCHPOS]);
			GrayDrawStr2B(CALC(80,115), CALC(25,39) + position*6,string,A_NORMAL,DPLANE,DPLANE);
			
			WeaponStatusLine(num, page);
			
		}
		
	}


}

void Init_background(void) {
	
	unsigned int loop1, loop2, loop3, x;
	
	GrayClearScreen();
  
  for (loop1 = 0; loop1 < CALC(7,10); loop1++) {
		for (loop2 = 0; loop2 <= 3; loop2++) {
			for (loop3 = 0; loop3 <= 2; loop3++) {
				x = loop2*3+loop1*24+loop3;
				if (x < CALC(160, 240)) {
					GrayFastDrawLine(x, 0, x, CALC(99,127), loop2);
				}
			}
		}
		for (loop2 = 0; loop2 <= 3; loop2++) {
			for (loop3 = 0; loop3 <= 2; loop3++) {
				x = loop2*3+loop1*24+12+loop3;
				if (x < CALC(160, 240)) {
					GrayFastDrawLine(x, 0, x, CALC(99,127), 3-loop2);
				}
			}
		}
	}
	
}


void Rectangle(void) {
	
	GrayDrawRect(CALC(4,39),CALC(10,24),CALC(156,201),CALC(92,103),COLOR_WHITE,RECT_FILLED);
	GrayDrawRect(CALC(5,40),CALC(11,25),CALC(155,200),CALC(91,102),COLOR_BLACK,RECT_EMPTY);
	
}

void Tankchose(unsigned int num) {
	
	unsigned int loop1 = 0;
	int key = 0;
	char string[5];
	
	if (player[num].type == 1) {
		for (loop1 = 1; loop1 <= TANKS; loop1++) {
			sprintf(string,"%d",loop1);
			GrayDrawStrExt2B(CALC(15,50) + loop1*16, CALC(60,74), string, A_NORMAL, F_6x8, DPLANE, DPLANE);
			Sprite16_OR(CALC(7,42) + loop1*16, CALC(70,84), 5, tanks[loop1-1], DPLANE);
		}
		
	 	while (key < 1 || key > TANKS) {
	 		key = KeyPressed();
	 		pokeIO(0x600005, 0b10111);
	 	}
		loop1 = key;

	}
	
	if (player[num].type == 2) {
		loop1 = random(TANKS) + 1;
	}
	
	player[num].tanknum = loop1;
	memcpy(player[num].tank, tanks[loop1 - 1], sizeof(tanks)/TANKS);
	
	Wait();
	
}

void Dispinf(unsigned int num) {
	
	char st_wind[8], st_angle[8], st_power[8], string[8];
	
	GrayDrawRect(0,0,CALC(159,239),CALC(16,20),COLOR_BLACK,RECT_FILLED);
	
	FontSetSys(CALC(F_4x6,F_6x8));
	GrayDrawStr2B(CALC(99,148),1,player[num].name,A_REVERSE,DPLANE,DPLANE);
	GrayDrawStr2B(1,1,(char*)"Angle",A_REVERSE,DPLANE,DPLANE);
	sprintf(st_angle,"%d",player[num].angle);
	GrayDrawStr2B(CALC(30,44),1,st_angle,A_REVERSE,DPLANE,DPLANE);
	GrayDrawStr2B(CALC(48,72),1,(char*)"Power",A_REVERSE,DPLANE,DPLANE);
	sprintf(st_power,"%d",player[num].power);
	GrayDrawStr2B(CALC(77,115),1,st_power,A_REVERSE,DPLANE,DPLANE);
	sprintf(st_wind,"%d",abs(game.wind));
	GrayDrawStr2B(CALC(144,215),1,st_wind,A_REVERSE,DPLANE,DPLANE);
	if (game.wind < 0) {
		GrayDrawStr2B(CALC(138,207),1,(char*)"\x15",A_REVERSE,DPLANE,DPLANE);
	}
	else if (game.wind > 0) {
		GrayDrawStr2B(CALC(153,229),1,(char*)"\x16",A_REVERSE,DPLANE,DPLANE);
	}
	GrayDrawRect(2, CALC(9,11), CALC(34,54), CALC(13,17), COLOR_WHITE, RECT_FILLED);
	if (player[num].health > 0) {
		GrayDrawRect(3, CALC(10,12), 3 + CALC(3,5)*player[num].health, CALC(12,16), COLOR_DARKGRAY, RECT_FILLED);
	}
	if (player[num].protect == PARACHUTE) {
		Sprite8_XOR_R(CALC(152,228), CALC(10,13), 4, parachute, DPLANE);
	}
	if (player[num].shield > 0) {
		Sprite8_XOR_R(CALC(133,199), CALC(8,11), 7, shield, DPLANE);
		sprintf(string, "%d", player[num].shield);
		GrayDrawStr2B(CALC(140,209), CALC(9,11), string, A_REVERSE, DPLANE, DPLANE);
	}
	GrayDrawStr2B(CALC(48,72),CALC(9,11),bombname[player[num].bomb[0]],A_REVERSE,DPLANE,DPLANE);
	
}

void Angle(unsigned int num, int key) {
	
	char st_angle[12];
	
	if (key == K_LEFT) {
		++player[num].angle;
	}
	else if (key == K_LEFT + K_2ND) {
		(player[num].angle) += 9;
	}
	
	else if (key == K_RIGHT) {
		--player[num].angle;
	}
	else if (key == K_RIGHT + K_2ND) {
		(player[num].angle) -= 9;
	}
	
	if (player[num].angle < 0) {
		player[num].angle = 0;
	}
	if (player[num].angle > 180) {
		player[num].angle = 180;
	}
	
	if (player[num].angle - player[num].angle_img >= 9 || player[num].angle - player[num].angle_img <= -9) {
		player[num].angle_img = player[num].angle;
		Tube(num);
	}
	
	sprintf(st_angle,"%d",player[num].angle);
	GrayDrawStrExt2B(CALC(30,44),1,CALC("      ","    "),A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	GrayDrawStrExt2B(CALC(30,44),1,st_angle,A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	
}

void Power(int *power, int key) {
	
	char st_power[12];
	
	if (key == K_UP) {
		++*power;
	}
	else if (key == K_UP + K_2ND) {
		(*power) += 10;
	}
	
	else if (key == K_DOWN) {
		--*power;
	}
	else if (key == K_DOWN + K_2ND) {
		(*power) -= 10;
	}
	
	if (*power < 1) {
		*power = 1;
	}
	if (*power > 100) {
		*power = 100;
	}
	sprintf(st_power,"%d",*power);
	GrayDrawStrExt2B(CALC(77,115),1,CALC("      ","    "),A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	GrayDrawStrExt2B(CALC(77,115),1,st_power,A_REVERSE,CALC(F_4x6,F_6x8),DPLANE,DPLANE);
	
}

void DeleteMenuEntry(unsigned int num) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < 15; loop1++) {
		Sprite8_AND_R(CALC(36,74) + 6*loop1, CALC(18,32) + 10*num, 8, font_mask, DPLANE);
	}
	
}

//ti89 version: completely done