/******************************************************************************
*
* project name:    Scorch
* file name:       Input##.c
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     all input routines
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include "main-h.h"

//extern-variables
extern INT_HANDLER save_int_1;
extern INT_HANDLER save_int_5;
extern PLAYERINF player[5];
extern LCD_BUFFER homescreen;
extern GAME game;
extern int earth[240];
extern int curfunc;

int KeyPressed(void) {
	
	if (_keytest(RR_F2)) {
		
		game.status = FASTQUIT;
		LeadOut();	
		
	}
	
	else if (_keytest(RR_APPS)) {
		
		if (curfunc != MAINMENU) {
			MainMenu();
		}
		
	}
	
	else if (_keytest(RR_ESC)) return K_ESC;
	
	#if defined(TI_BIG)
	else if (_keytest(RR_ENTER1) || _keytest(RR_ENTER2) || _keytest(RR_HAND)) return K_ENTER;
	#elif defined(TI_SMALL)
	else if (_keytest(RR_ENTER1) || _keytest(RR_ENTER2) || _keytest(RR_HOME)) return K_ENTER;
	#endif
	
	else if (_keytest(RR_2ND) && _keytest(RR_LEFT)) return K_LEFT + K_2ND;
	
	else if (_keytest(RR_LEFT)) return K_LEFT;
	
	else if (_keytest(RR_2ND) && _keytest(RR_RIGHT)) return K_RIGHT + K_2ND;
	
	else if (_keytest(RR_RIGHT)) return K_RIGHT;
	
	else if (_keytest(RR_2ND) && _keytest(RR_UP)) return K_UP + K_2ND;
	
	else if (_keytest(RR_UP)) return K_UP;
	
	else if (_keytest(RR_2ND) && _keytest(RR_DOWN)) return K_DOWN + K_2ND;
	
	else if (_keytest(RR_DOWN)) return K_DOWN;
	
	
	else if (_keytest(RR_1)) return K_1;
	
	else if (_keytest(RR_2ND) && _keytest(RR_2)) return K_2 + K_2ND;
	
	else if (_keytest(RR_2)) return K_2;
	
	else if (_keytest(RR_3)) return K_3;
	
	else if (_keytest(RR_4)) return K_4;
	
	else if (_keytest(RR_5)) return K_5;
	
	else if (_keytest(RR_6)) return K_6;
	
	else if (_keytest(RR_7)) return K_7;
	
	#if defined(TI_BIG)
	else if (_keytest(RR_Q)) return K_Q;
	#elif defined(TI_SMALL)
	else if (_keytest(RR_MODE)) return K_Q;
	#endif
	
	else if (_keytest(RR_PLUS)) {
		OSContrastUp();
		Wait();
		return K_PLUS;
	}
	
	else if (_keytest(RR_MINUS))  {
		OSContrastDn();
		Wait();
		return K_MINUS;
	}
	
	return 0;
	
}


void Waitkey(void) {
	
	while(_rowread(0)) continue;
	
	while(!KeyPressed()) {
		pokeIO(0x600005, 0b10111);
	}
	
	while(_rowread(0)) continue;
	
}


void Wait(void) {
	while(_rowread(0)) continue;
}


void Inputstr(char *name, unsigned short maxlen) {
  
  FontSetSys(F_6x8);
  short key = 0;
  unsigned short position = 0;
  
  #if defined(TI_SMALL)
  	SetAlphaStatus(TRUE);
  #endif
  
  GraySetInt1Handler(save_int_1);
  
  GraySetAMSPlane(DARK_PLANE);
  
  name[0] = 0;
 	DrawStr(CALC(10,45),CALC(31,45),"Name: ",A_NORMAL);
 	while (key != KEY_ENTER) {
 		DrawStr(CALC(58,93),CALC(31,45),"         ",A_SHADED);
  	DrawStr(CALC(58,93),CALC(31,45),name,A_NORMAL);
  	DrawStr(CALC(58,93) + 6*position, CALC(31,45), "_",A_NORMAL);
  	key = ngetchx ();
  	if (key == KEY_F2) {
  		game.status = FASTQUIT;
  		LeadOut();
  	}
  	else if (key >= ' ' && key <= '~' && position < maxlen) {
  		name[position++] = key;
   	}
  	else if (key == KEY_BACKSPACE && position) {
			position--;
  	}
  	name[position] = 0;
	}
  DrawStr(CALC(58,93) + 6*position,CALC(31,45)," ",A_SHADED);
  
  GraySetInt1Handler(DUMMY_HANDLER);
  
  #if defined(TI_SMALL)
  	SetAlphaStatus(FALSE);
  #endif
  
}

//ti89 version: completely done