/******************************************************************************
*
* project name:    Scorch
* file name:       data##.h
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     all kind of data
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

//various strings
const char *compnames[] = {"Franz","Matthias","Master","Gangster","Glatze"};
const char *landscape[] = {"very flat","flat","hilly","quite hilly","mountainous","very mountainous","random"};
const char *aistrenght[] = {"stupid","easy","random"};//"easy","normal","hard","extreme","random"};
const char *wind[] = {"none", "constant low", "constant middle", "constant high","random"};
const char *bombname[] = {"","Baby Missile","Missile","Baby Nuke","Nuke","Napalm","Hot Napalm",
													"Laser little","Laser big","Battery","Parachute","Shield little","Shield big"};
const char *bombcost[] = {"         free","  5 for 1000cr","  2 for 2000cr.","  1 for 4000cr.",
													"  2 for 2500cr.","  1 for 5000cr.","  2 for 3000cr.","  1 for 5000cr.",
													"  5 for 1000cr.","  2 for 5000cr.", "  2 for 4000cr.", "  1 for 5000cr."
													};
const char *gamefile = "scorchgs";

/*unsigned char fire_l[] = {0x22, 0x22, 0x77, 0x77, 0x22};
unsigned char fire_d[] = {0x00, 0x00, 0x22, 0x22, 0x22};*/
/*unsigned char fire_l[] = {0x40, 0x60, 0xE0, 0xF0, 0xF0, 0x60};
unsigned char fire_d[] = {0x00, 0x00, 0x00, 0x40, 0x60, 0x60};*/
/*unsigned char fire_l[] = {0x08, 0x08, 0x08, 0x14, 0x14, 0x22, 0x22, 0x49, 0x49, 0x5D, 0x3E, 0x1C};
unsigned char fire_d[] = {0x00, 0x00, 0x00, 0x08, 0x08, 0x1C, 0x1C, 0x3E, 0x3E, 0x3E, 0x1C, 0x08};*/
unsigned char fire_l[] = {0x14, 0x80, 0x20, 0x04, 0x4E, 0x0A, 0x12, 0x57, 0xFF, 0xBD, 0xDD, 0x5A};
unsigned char fire_d[] = {0x00, 0x02, 0x00, 0x00, 0x00, 0x84, 0x0C, 0x0C, 0x1E, 0x7E, 0x3E, 0x3E};

unsigned char parachute[] = {0x38,0x44,0xAA,0x10};
unsigned char shield[] = {0xFE,0xF2,0xF2,0xFE,0x9E,0x5C,0x38};

//unsigned char projectile[] = {0x01, 0x00, 0x00, 0x00};

int merchpage[] = {6, 6};

unsigned char mask[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
//unsigned short tank_mask_top[] = {0xC01F,0x800F,0x800F,0x0007,0x0007};
unsigned short tank_mask[] = {0xC01F,0xC01F,0xC01F,0xC01F,0xC01F};
//unsigned short tank_mask[] = {0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F,0xC01F};

unsigned char tube[21][4] = {
													 	{0x00, 0x00, 0x00, 0x0F},
														{0x00, 0x00, 0x03, 0x0C},
														{0x00, 0x00, 0x07, 0x08},
														{0x00, 0x01, 0x06, 0x08},
														{0x00, 0x03, 0x04, 0x08},
														{0x01, 0x02, 0x04, 0x08},
														{0x02, 0x04, 0x04, 0x08},
														{0x04, 0x04, 0x08, 0x08},
														{0x04, 0x08, 0x08, 0x08},
														{0x08, 0x08, 0x08, 0x08},
														{0x08, 0x08, 0x08, 0x08},
														{0x08, 0x08, 0x08, 0x08},
														{0x10, 0x08, 0x08, 0x08},
														{0x10, 0x10, 0x08, 0x08},
														{0x20, 0x10, 0x10, 0x08},
														{0x40, 0x20, 0x10, 0x08},
														{0x00, 0x60, 0x10, 0x08},
														{0x00, 0x40, 0x30, 0x08},
														{0x00, 0x00, 0x70, 0x08},
														{0x00, 0x00, 0x60, 0x18},
														{0x00, 0x00, 0x00, 0x78}
													  };

unsigned int tank_pixel_mass[] = {18, 24, 25, 20, 20, 17, 19};

unsigned int bomb_skill[MERCH][3] = {
																				{0, 0, 1},
																				{5, 1000, 4},
																				{2, 2000, 8},
																				{1, 4000, 16},
																				{2, 2500, 50},
																				{1, 5000, 100},
																				
																				{2, 3000, 50},
																				{1, 6000, 100},
																				{5, 1000, 0},
																				{2, 5000, 0},
																				{2, 4000, 10},
																				{1, 5000, 30}
																				
																				};

unsigned short tanks[TANKS][5] = {{0x38,0x10,0x7C,0xAA,0x7C}, 
																	{0x38,0x7C,0xFE,0xAA,0x7C},
																	{0x7C,0x38,0xFE,0xFE,0x54},
																	{0x7C,0x38,0x7C,0xBA,0x44},
																	{0x38,0x44,0x7C,0xD6,0x7C},
																	{0x10,0x28,0x44,0xFE,0x7C},
																	{0x7C,0x38,0x6C,0x6C,0x92}};


unsigned short cloud1[] = {0x073E, 0x1FFF,0x7FFF,0xFFFE,0x7FFE,0x1DA7};

unsigned char font_mask[] = {0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA};