/******************************************************************************
*
* project name:    Scorch
* file name:       definitions##.h
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     all kind of definitions
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#define COMMENT_VERSION_STRING "v.1.2 beta"

// object-like-macros
// shot globals
#define GRAVITATION			32
#define POWERFACTOR			1.5
#define TUBELENGTH			3.2

#define MASSKILL				10

#define FILLED					1
#define OUTLINED				2
#define PRE							1
#define AFTER						2


//function-values
#define WELCOME					1
#define PL_SETTINGS			2
#define GA_SETTINGS			3
#define GAMELOOP				4
#define PLAYROUND				5
#define STATISTICS			6
#define SHOP						7
#define MAINMENU				8

// bombs and other things
#define MERCH						12
#define MPP							6
//#if defined(TESTING)
//#define PAGES						(int)(MERCH/MPP)+1
//#else
#define PAGES						2
//#endif
#define MERCHPOS				position + (page - 1)*MPP

#define AISTRENGTH			3

#define BABYMISSILE			1
#define MISSILE					2
#define BABYNUKE				3
#define NUKE						4
#define NAPALM					5
#define HOTNAPALM				6
#define LASERLITTLE			7
#define LASERBIG				8
#define BATTERY					9
#define PARACHUTE				10
#define SHIELDLITTLE		11
#define SHIELDBIG				12

// number of tanks
#define TANKS						7

// delay
#define AUTO_REPEAT			50

// trigonometry in degree
#define sin_deg(x_) 		sin((x_)*(PI/180.)) 
#define cos_deg(x_) 		cos((x_)*(PI/180.))

#define ABS(a)					(((a)<0) ? -(a) : (a))

// status-values
#define FASTQUIT			 -3
#define QUIT					 -2
#define NEWGAME				 -1
#define NORMAL					0
#define NEWROUND				1
#define ENDGAME					2
#define GAMELOADED			3

//grayscale-planes
#define LPLANE					GrayGetPlane(0)
#define DPLANE					GrayGetPlane(1)

//key-values
#define K_F2						-10
#define K_APPS					-5
#define K_ESC						-1

#define K_1							1
#define K_2							2
#define K_3							3
#define K_4							4
#define K_5							5
#define K_6							6
#define K_7							7

#define K_UP						11
#define K_DOWN					12
#define K_RIGHT					13
#define K_LEFT					14

#define K_ENTER					20

//#define K_A							31
//#define K_C							32
//#define K_H							33
//#define K_L							34
//#define K_P							35
#define K_Q							36
//#define K_R							37

#define K_PLUS					50
#define K_MINUS					51

#define K_2ND						100


// structures
// structure for gamesettings
typedef struct {
	int status;
	//unsigned int ai_factor;
	unsigned int land_factor;
	unsigned int wind_factor;
	unsigned int rounds_now, rounds;
	unsigned int pl_num, pl_active, pl_check, pl_alive;
	int wind;
} GAME;

// structure for the coordinates of the shoot
typedef struct {
	int x_new;		// actual x
	int x_old;		// old x
	int x_eld;
	int x_ild;
	int y_new;		// actual y
	int y_old;		// old y
	int y_eld;
	int y_ild;
} COORDINATES;

typedef struct {
	int x;
	int y;
}	TARGET;

// structure for player-informations
typedef struct {
					// coordinates, angles, health, power
					int x, y, angle, angle_img, health, power, protect, shield;
					//bombs, tank, victorys, playertype, life/dead, credits, tankimage
					unsigned int bomb[MERCH+1], tanknum, victory, type, life, credits;
					int short tank[5];
					// name..
					char name[9];
					// for computer --> ai: hit = chosen player; try = attempts
					unsigned int target, strength;
					
} PLAYERINF;

typedef struct {
	
	GAME game;
	PLAYERINF player[5];
	int earth[240];
	
} SAVEGAME;

// extern variables
INT_HANDLER save_int_1;
INT_HANDLER save_int_5;
PLAYERINF player[5];
LCD_BUFFER homescreen;
GAME game;
int earth[240];
int curfunc;
