/******************************************************************************
*
* project name:    Scorch
* file name:       functions##.h
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     declaration of all functions
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/


// declaration of functions
// Main##.c
void _main(void);
void Intro(void);
void Welcome(void);
void GameLoop(void);
void PlayRound(void);
void Extro(void);
void Delay(unsigned int);
void LeadOut(void);
void MainMenu(void);
void Memory(void);
short IsVTI(void);
void VTIPoking(void);
void Debugging(unsigned int);

// Input##.c
int KeyPressed(void);
void Waitkey(void);
void Wait(void);
void Inputstr(char *, unsigned short);

// Gamefunc##.c
void Landscape(unsigned int);
void DrawScreen(void);
void InitRound(void);
void Tankset(unsigned int);
void DrawTank(unsigned int, unsigned int);
void MaskTank(unsigned int);
void Tube(unsigned int);
void MainShot(unsigned int, TARGET *);
void ShotEngine(unsigned int, TARGET *);
int CheckImpact(int, int, int, int, TARGET *);
void Clip_circle(int, int, int, int, unsigned int);
void CirclePixel(int, int, int);
void Napalm(int, unsigned int);
void Explosion(unsigned int, unsigned int, unsigned int);
void Earth_control(int, int);
void Health_control(unsigned int, int, int);
void CalcHealth(unsigned int, int);
void Tank_fall(void);
void Inventory(unsigned int);
void MassKill(void);
//void Clouds(void);
//void Background(void);

// Extern##.c
unsigned char *GetDataPtr(const char *, short);
void Archive(const char *);
void Unarchive(const char *);
void SaveGame(void);
short LoadGame(void);
void DecompRLEVert(unsigned char *, unsigned char *, int, int, int);

// Gui##.c
void P_R_choose(void);
void PlayerSettings(void);
void Player_init(unsigned int);
void DrawSettings(void);
void GameSettings(void);
void Statistics(void);
void WeaponList(unsigned int, unsigned int, unsigned int);
void WeaponStatusLine(unsigned int, unsigned int);
int WeaponCursor(int, unsigned int);
void Shop(unsigned int);
void Init_background(void);
void Rectangle(void);
void Tankchose(unsigned int);
void Dispinf(unsigned int);
void Angle(unsigned int, int);
void Power(int *, int);
void DeleteMenuEntry(unsigned int);

// pixcollide8.s
short PixCollide8(register short x0 asm("%d1"),
									register short y0 asm("%d0"), 
									register short x1 asm("%d2"), 
									register short y1 asm("%d3"), 
									register short height asm("%d4"), 
									register unsigned char* data1 asm("%a0"))__attribute__((__regparm__(6)));

// Ai##.c
void AiMain(TARGET *, unsigned int);
void ChooseEnnemi(unsigned int, int);
void AiShop(void);
unsigned int BuildItemList(unsigned int *, unsigned int);
void ChooseWeapon(unsigned int);
void ChooseArmor(unsigned int);
//void Aidata(void);

